100 REMark NETPAL 0.6 - a QL remote command server
110 REMark for people with more QLs than Monitors
120 REMark (and why not - they're cheaper!)
130 REMark Copyright 1990 Simon N Goodwin, v 0.6
140 :
150 REMark Changes from 0.5 - lazy delete left - slower
160 REMark but less risk of characters getting lost.
170 REMark - CSIZE 1,0 is now set on the remote machine.
180 REMark - BAD LINE no longer crashes the link - it
190 REMark is simply ignored, as v0.6 enters an ESC
200 REMark (on Minerva) and ERNUM is not set thereafter.
210 :
220 REMark OPERATIONAL NOTES:
230 REMark The controlling machine must be made to
240 REMark FSERVE so that NETPAL can access it.
250 REMark The controlled machine runs this program.
260 REMark You need the SuperToolkit 2 ROM at both ends.
270 :
280 REMark IMPLEMENTATION NOTES:
290 REMark Leave the per cent off the name TXTLEN%
300 REMark unless running on MINERVA.
310 REMark Add IMPLICIT% TXTLEN if compiling with TURBO
320 REMark - unless you are running the Minerva ROM.
330 REMark The vital BAD_LINE escape trap needs Minerva.
340 REMark PIX requires the MEM device at the other end.
350 :
360 REMark If you omit CANCEL_ERROR you will probably
370 REMark see one spurious error report at the start;
380 REMark ignore it: your QDOS has bad manners!
390 :
400 CANCEL_ERROR
410 escape$=CHR$(27)
420 back$=CHR$(194) : enter$=CHR$(10)
430 prompt$ = "NETPAL>" : command$=""
440 :
450 STARTUP : HEADING
460 REMark MAIN LOOP
470 REMark Adjust the second TYPE_IN, below
480 REMark if you renumber the next line!
490 REPeat main_loop
500   IF ERNUM
510     PAPER #3,2 : PRINT #3;"ERROR: ";command$;
520     PAPER #3,0 : INK #3,4 : REPORT #3 : INK #3,7
530     CANCEL_ERROR
540   END IF
550   PROMPT
560   GETLINE command$
570   IF command$ <> "" : EXIT main_loop
580 END REPeat main_loop
590 REMark DIY Toolkit QUEUE% is like TYPE_IN
600 TYPE_IN command$
610 REMark The next command requires Minerva
620 TYPE_IN escape$ : REMark Escape from BAD LINE
630 REMark But beware of CTRL-F5 lockups!
640 TYPE_IN "RUN 490" & enter$
650 STOP
660 :
670 DEFine PROCedure GETLINE(txt$)
680 LOCal key$(1),txtlen%,scrub%,s%
690 txt$=""
700 REPeat get_key
710   key$=INKEY$(#3,-1)
720   scrub%=0 : REMark No characters to be deleted yet
730   REPeat do_keys
740     txtlen%=LEN(txt$)
750     IF key$ = back$
760       IF txtlen% > 0
770         scrub%=scrub%+1
780       END IF
790       SELect ON txtlen%
800         =0 : CLS #3,115 : PRINT #3," "; : CLS #3,115
810         =1 : txt$=""
820         =REMAINDER : txt$=txt$(1 TO LEN(txt$)-1)
830       END SELect
840     ELSE
850       txt$=txt$ & key$
860     END IF
870     IF key$=enter$ : EXIT get_key
880     REMark Check for type-ahead
890     key$=INKEY$(#3,0) : IF LEN(key$)=0 : EXIT do_keys
900   END REPeat do_keys
910   FOR s%=1 TO scrub% : SCRUB1
920   FLUSH #3
930 END REPeat get_key
940 FLUSH #3
950 RETurn txt$ & enter$
960 END DEFine
970 :
980 DEFine PROCedure CANCEL_ERROR
990 REMark This is meant to clear the BASIC
1000 REMark system variable ERLIN once an error
1010 REMark has been reported. I welcome ideas as
1020 REMark to easier ways to do this!
1030 :
1040 REMark The next line needs TURBO TOOLKIT, and
1050 REMark assumes BASIC sysvars occupy 256 bytes.
1060 POKE_L BASIC_POINTER(0)-256+194,0
1070 :
1080 REMark A better DIY Toolkit alternative is:
1090 REMark FOR p=194 to 197 : BPOKE p,0
1100 END DEFine
1110 :
1120 DEFine PROCedure HELP
1130 CLS #3 : INK #3,4
1140 PRINT #3,"NETPAL types comands on a remote QL as"
1150 PRINT #3,"if you typed them there yourself."
1160 PRINT #3,"It uses the QL network file server."
1170 PRINT #3,\"NETPAL supports all QL commands - but"
1180 PRINT #3,"it is itself written in SuperBASIC, so"
1190 PRINT #3,"NEW, LRUN, LOAD CLEAR etc. disturb it!"
1200 PRINT #3, "CTRL  is the only edit key recognised,"
1210 PRINT #3;"and you CAN'T use it to move UP a line."
1220 PRINT #3;"Don't type fast or you'll beat the net!"
1230 PRINT #3,\"PROMPT$ is the prompt, and can include"
1240 PRINT #3,"the date - for instance, try entering"
1250 INK #3,7
1260 PRINT #3,"prompt$ = 'It is now date :'";
1270 INK #3,4 :PRINT #3;" or "; : INK #3,7
1280 PRINT #3,"= ''" : INK #3,4
1290 PRINT #3,\"Channel #3 is the remote display. Try:"
1300 INK #3,7
1310 PRINT #3,"DIR #3"; : INK #3,4 : PRINT #3," or ";
1320 INK #3,7 : PRINT #3,"RECOL #3,7,6,5,4,3,2,1,0"
1330 INK #3,4 : PRINT #3,"The command "; : INK #3,7
1340 PRINT #3,"PIX "; : INK #3,4
1350 PRINT #3;"reads the other screen."
1360 INK #3,7 : PRINT #3
1370 FLUSH #3
1380 END DEFine
1390 :
1400 DEFine PROCedure PROMPT
1410 REMark Format & display the prompt message
1420 dpos%="date" INSTR prompt$
1430 IF dpos% <> 0
1440   IF dpos% > 1
1450     PRINT #3;prompt$(1 TO dpos%-1);
1460   END IF
1470   PRINT #3;DATE$;
1480   IF dpos%+3 < LEN(prompt$)
1490     PRINT #3;prompt$(dpos% +4 TO);
1500   END IF
1510 ELSE
1520   PRINT #3;prompt$;
1530 END IF
1540 END DEFine
1550 :
1560 DEFine PROCedure STARTUP
1570 OPEN #3,n1_con_480x200a32x4
1580 END DEFine
1590 :
1600 DEFine PROCedure HEADING
1610 CLS #3 : CSIZE #3,2,1
1620 PRINT #3,"QL NETPAL version 0.6" : CSIZE #3,1,0
1630 PRINT #3;"Enter HELP for HELP." : INK #3,7
1640 END DEFine
1650 :
1660 DEFine PROCedure SCRUB1
1670 REMark Move remote cursor back 2 places
1680 CLS #3,115 : CLS #3,115
1690 REMark Wipe out deleted character & splodge
1700 PRINT #3,"  ";
1710 REMark Move cursor to end of remaining text
1720 CLS #3,115 : CLS #3,115
1730 END DEFine
1740 :
1750 DEFine PROCedure PIX
1760 REMark Copies a screen over the network.
1770 REMark This needs a MEM device on the other QL.
1780 REMark It's very slow unless you can use PEEK$.
1790 REMark Omit %s after ROW & COL without Minerva
1800 LOCal p,row%,col%,temp$
1810 INK #3,4
1820 PRINT #3;\\\\\"Loading other display... check MODE!"
1830 PRINT #3;\"Wait to see the whole display, then"
1840 PRINT #3;"press ENTER to re-start command entry."
1850 OPEN #3,"n1_mem"
1860 LET p=131072 : REMark Assumed base of 32K screen
1870 PUT #3\p
1880 FOR row%=0 TO 255
1890   REMark The next line needs TURBO Toolkit:
1900   PRINT #3,PEEK$(p+row%*128,128);
1910   REMark alternatively, use the next three lines:
1920   REMark FOR col%=row%*128 TO row%*128+127 STEP 2
1930   REMark   PUT #3,PEEK_W(p+col%)
1940   REMark END FOR col%
1950 END FOR row%
1960 STARTUP
1970 INPUT #3,temp$
1980 HEADING
1990 END DEFine
2000 :
