2 IMPLICIT% black,white,red,green,index,temp,first,last,top_limit,reason
3 IMPLICIT% stepping_offset,block_size,tracks,cylinder_size,track_size
4 IMPLICIT% total_blocks,block_bytes,block_no,xlator,name_length
5 IMPLICIT% sector_no,track,offset,sector,side,c
8 DATA_AREA 8
12   WHEN_ERROR
15     reason=ERLIN%
20     SELect ON reason
25      =240
30       COMPLAIN "This interface does not allow direct access to data."
35       STOP
40       =280 : COMPLAIN "Format description is unreadable."
45       =650,1550 : COMPLAIN "Please enter first and last block numbers."
50       =690,1500,1530 : COMPLAIN "Unable to open " & file$
55       =1120 : read_ok=0 : REMark Set flag for trapper
60         PRINT #4\"BLOCK " & block_no & " IS UNREADABLE."\\
65       =REMAINDER 
70         reason=ERNUM%
75         SELect ON reason
80           =-11
85             COMPLAIN "Drive full."
86           =-1,-5,-6,-9,-10,-16,-20
88             COMPLAIN "Output failure (code " & reason & ")."
90           =REMAINDER 
95             COMPLAIN "Unexpected error " &ERNUM% &" at "&ERLIN% &"."
100        END SELect 
105        CLOSE #3 : CLOSE #4 : GO TO 165 : REMark Messy but maybe OK
110     END SELect 
115     RETRY
120   END_WHEN
125 :
130 DIM sector$(512),k$(10),dname$(10),file$(44)
135 dname$="FLP1_*D2D" : top_limit=191
140 black=0 : red=2 : green=4 : white=7
145 INK #0,white : PAPER #0,black : CSIZE #0,1,0
150 PAPER black : INK white
155 MODE 4 : CLS #0
160 REPeat startup_loop
165   RETRY_HERE
170   HEADING
175   INK green
180   PRINT \"      This program will not attempt to write to ";dname$;
185   PRINT " but it is "\"      good practice to write-protect all ";
190   PRINT "disks used in that drive." : INK white
195   PRINT
200   PRINT "Please put a good disk of the same format as the faulty one"
205   INPUT "in ";(dname$);" then press ENTER, or Q to Quit ";k$
210   IF k$=="Q" : EXIT startup_loop
215   IF LEN(k$)=9 : dname$=k$
240   OPEN #3,dname$
250   PRINT
260   :
270   REMark Read format-dependent information
280   GET #3\1 : sector$=INPUT$(#3,512)
290   IF sector$(1 TO 4)<>"QL5A"
300     COMPLAIN "Disk is not in QL format." : NEXT startup_loop
310   END IF 
320   stepping_offset=STRING%(sector$(39 TO 40))
330   block_size     =STRING%(sector$(33 TO 34))
340   tracks         =STRING%(sector$(31 TO 32))
350   cylinder_size  =STRING%(sector$(29 TO 30))
360   track_size     =STRING%(sector$(27 TO 28))
370   total_blocks   =STRING%(sector$(25 TO 26)) DIV block_size
380   block_bytes    =block_size * 512
390   DIM xlator(cylinder_size-1),block$(block_bytes)
400   :
405   INK green : PRINT "      ";
410   IF track_size=block_size : PRINT "Singl"; : ELSE PRINT "Doubl";
420   PRINT "e sided disk, ";tracks;" tracks with ";
430   PRINT cylinder_size;" sectors of 512 bytes each."
440   PRINT "      Disk space is divided into ";total_blocks;
450   PRINT " blocks of ";block_bytes;" bytes each."
460   PRINT
465   INK white
470   :
480   REMark Read logical to physical translation data
490   FOR index=0 TO cylinder_size-1
500     temp=CODE(sector$(41+index))
510     IF temp>127 : temp=temp+128 : REMark Weight for SIDE 1 = 256
520     xlator(index)=temp
530   END FOR index
540   :
550   PRINT "Please replace the faulty disk for file recovery."
560   INPUT "Enter S to Scan disk, R to Recover data or Q to Quit ";k$
570   IF k$=="S" : SCAN_DISK
580   IF k$=="R" : RECOVER_FILE
590   IF k$=="Q" : EXIT startup_loop
600 END REPeat startup_loop
602 INK green
605 PRINT \"Data recovery program finished."
610 STOP
620 :
630 DEFine PROCedure SCAN_DISK
635 HEADING : INK green
637 PRINT \"       Ready to scan disk - disk blocks are numbered from ";
640 PRINT "0 to ";total_blocks-1;"."
642 INK white
645 RETRY_HERE
650 INPUT \"Enter first & last block numbers to be scanned "\first\last
660 IF last>=total_blocks : last=total_blocks-1
670 IF first<0 : first=0
675 RETRY_HERE
680 INPUT \"Enter output device name for report ";file$
685 IF LEN(file$)<3 : file$="SCR_448x200a32x16"
690 OPEN_NEW #4,file$
695 on_screen=file$(1 TO 3)=="scr" : IF on_screen
697   CLS #4 : CURSOR_ON #0!
698   PRINT #0;"  Press CTRL-F5 to pause, or ESC to quit."
699 END IF 
700 file$="" : busy=0
710 FOR index=first TO last
720   GET_BLOCK index
730   PRINT #4;"Block ";index
740   IF CODE(block$(1))=0
750     REMark It may be a file header: length is < 2^24
760     name_length = STRING%(block$(15 TO 16))
770     IF name_length>=0 AND name_length<=36
780       REMark Name seems plausible
790       IF CODE(block$(4))=64
800         SHOW_HEADER
810       END IF 
820     END IF 
830   END IF 
840   PRINT #4;"          Start: ";TIDY$(block$(1 TO 50))
850   PRINT #4;"          End  ";
860   IF busy AND block$(block_bytes-9 TO block_bytes)="0000000000"
870     PRINT #4;"of file '";file$;"' inferred at block ";index
880     busy=0
890   ELSE 
900     PRINT #4;": ";TIDY$(block$(block_bytes-49 TO block_bytes))
910   END IF 
915   IF on_screen
917     IF INKEY$(#0,1)=CHR$(27) : EXIT index
918   END IF 
920 END FOR index
925 IF on_screen : CURSOR_OFF #0
930 CLOSE #4 : CLOSE #3
935 CLS #0 : COMPLAIN ""
940 END DEFine 
950 :
960 DEFine PROCedure SHOW_HEADER
970 file$=TIDY$(block$(17 TO 16+name_length))
980 PRINT #4;"          **** Start of file '";
990 PRINT #4;file$;"' ****"
1000 busy=1
1010 END DEFine 
1020 :
1030 DEFine PROCedure TRUE_SECTOR(sector_no)
1040 track = sector_no DIV cylinder_size
1050 offset = track * stepping_offset
1060 sector = sector_no MOD cylinder_size
1070 side = xlator(sector) && 256
1080 sector = ((xlator(sector) && 127) + offset) MOD track_size
1090 REMark PRINT "Logical sector: ";sector_no;
1100 REMark PRINT " is physical track ";track;
1110 REMark PRINT " side ";side<>0;" sector ";sector
1120 GET #3\track*65536+side+sector+1 : sector$=INPUT$(#3,512)
1130 REMark PRINT #0,sector$
1140 END DEFine 
1150 :
1160 DEFine PROCedure GET_BLOCK(block_no)
1170 LOCal index,read_ok
1180 block$="" : read_ok=1
1190 FOR index=block_no * block_size TO (block_no + 1) * block_size - 1
1195   RETRY_HERE
1197   IF read_ok
1200     TRUE_SECTOR index
1210     block$ = block$ & sector$
1215   ELSE block$=FILL$("X",block_size) : EXIT index
1217   END IF 
1220 END FOR index
1230 REMark PRINT "Block ";block_no\block$
1240 END DEFine 
1250 :
1260 DEFine PROCedure COMPLAIN(moan$)
1270 IF LEN(moan$)<>0 : PAPER #0,red :CLS #0 : PRINT #0;"  ";moan$
1280 INPUT #0,\,,"Press ENTER to continue ";k$
1290 PAPER #0,black : CLS #0
1300 END DEFine 
1310 :
1320 DEFine FuNction TIDY$(text$)
1330 LOCal index,c
1340 FOR index=1 TO LEN(text$)
1350   c=CODE(text$(index))
1360   IF c<32 : text$(index)="?"
1370   IF c>top_limit : text$(index)="!"
1380 END FOR index
1390 RETurn text$
1400 END DEFine 
1410 :
1420 DEFine PROCedure RECOVER_FILE
1430 HEADING : INK white
1450 REPeat recovery_loop
1455   RETRY_HERE
1460   PRINT \"Enter name of file for recovered data (or enter nothing";
1465   INPUT " to restart) "\file$
1470   IF file$="" : EXIT recovery_loop
1480   status=DEVICE_STATUS(1,file$)
1490   IF status=-7
1500     OPEN_NEW #4,file$
1510   ELSE 
1520     IF status<1536
1525       COMPLAIN "Unable to open '"& file$ &"', error code: "&status
1527       NEXT recovery_loop
1528     END IF 
1530     OPEN #4,file$ : GET #4\1E7
1540   END IF 
1545   RETRY_HERE
1550   INPUT \"Enter first & last block numbers"\first,last
1552   INK green
1555   PRINT \"Writing to ";file$
1560   FOR index=first TO last
1570     GET_BLOCK index
1580     IF index=first
1590       IF status=-7
1600         PRINT #4;block$(65 TO); : NEXT index : EXIT index
1610       END IF 
1620     END IF 
1630     PRINT #4,block$;
1640   END FOR index
1650   CLOSE #4
1660   PRINT \file$;
1670   IF status=-7 : PRINT " created." : ELSE PRINT " extended."
1675   INK white
1680 END REPeat recovery_loop
1690 CLOSE #3
1700 END DEFine 
1710 :
1720 DEFine PROCedure HEADING
2150 CLS : CSIZE 2,0 : INK green,white
2152 PRINT "QL disk data recovery program v 1.03,"
2155 PRINT "   Copyright 1989 Simon N Goodwin."
2157 CSIZE 0,0
2167 END DEFine 
