100 REMark Program to convert any Task into a Resident Procedure
105 REMark TURBO TOOLKIT version 1.4, with full parameter passing
110 maxcode=2^20 :REMark DIY fast load limits tasks to 1 Megabyte
115 scrbase=131072 : REMark Alter if using Minerva 2 screens
120 scrposn=scrbase+3840 : scrsize=19200 : REMark Suit my window
125 :
130 popup=ALLOCATION(scrsize):REMark Screen buffer
135 IF popup>0 : MOVE_MEMORY scrsize,scrposn TO popup
140 IF COMPILED : OPEN #1,CON :REMark Avoid messing up screen
145 WINDOW 400,150,36,30 : BORDER 2,0,7 : PAPER 0 : CLS
150 PAPER 2 : INK 7,4 : CSIZE 2,1 : CLS 3
155 PRINT "TURBO COMMANDER - file converter"
160 PAPER 7 : INK 2 : CSIZE 1,0 : CLS 3
165 PRINT "    Written by Phil Borman & Simon N Goodwin."
170 INK 4 : PAPER 0 : pass=0
175 WINDOW 376,110,48,65
180 :
185 REPeat maker
190   PRINT : pass=pass+1
195   IF OPTION_CMD$="" OR pass>1
200     INPUT 'Source file >'!source$
205   ELSE
210     source$=OPTION_CMD$
215     PRINT 'Source file ='!source$
220   END IF
225   IF source$="" : EXIT maker
230   fault=DEVICE_STATUS(1,source$)
235   IF fault<0 : PRINT 'Error'!fault!'reading'!source$ : NEXT maker
240   OPEN_IN #3,source$
245   SET_POSITION #3,maxcode+1
250   file_length=POSITION(#3)
255   CLOSE #3
260   IF file_length>maxcode OR 2*INT(file_length/2)<>file_length
265     PRINT source$!"has odd or excessive size" : NEXT maker
270   END IF
275   file_data=DATASPACE(source$)
280   IF file_data<16 : PRINT source$;" data space too small" : NEXT maker
285   INPUT 'Destination >'!destin$
290   INPUT 'Keyword     >'!name$\\
295   NL%=LEN(name$)
300   IF NL%=0 : PRINT "Huh?" : EXIT maker
305   buffer=ALLOCATION(file_length+280+NL%)
310   IF buffer<0 : PRINT "Fatal error - insufficient free RAM" : EXIT maker
315   b=buffer : RESTORE 640 : DATASTORE 640 :REMark Store BP.INIT code
320   offset=6+NL%-(NL% && 1) :REMark Find the PROC code
325   POKE_W b,(NL%+8) DIV 8 : POKE_W b+2,offset+8 : POKE b+4,NL%
330   FOR i=5 TO NL%+4 : POKE i+b,CODE(name$(i-4)) && -33
335   b=b+offset : POKE_L b,0 : POKE_W b+4,0 : b=b+6 : base=b
340   FOR lnum=660 TO 790 STEP 10 : DATASTORE lnum
345   POKE_L base+124,file_data : POKE_L base+130,file_length
350   LBYTES source$,b :REMark Load task to end of code
355   size=file_length+b-buffer
360   REPeat try
365     fault=DEVICE_STATUS(2,destin$)
370     SELect ON fault
375       ON fault=-8
380         PRINT destin$!'already exists - Delete (Y/N) ? ';
385         k$=INKEY$(#1,-1) : PRINT k$
390         IF k$=='y' THEN DELETE destin$ : NEXT try
395       ON fault=0 TO size-1
400         PRINT 'Insufficient space on drive for '!destin$
405       ON fault=size TO 1E99
410         SBYTES destin$,buffer,file_length+b-buffer
415         PRINT \name$!"keyword code has been created in"!destin$
420       ON fault=REMAINDER
425         PRINT 'Qdos error'!fault!'writing'!destin$
430     END SELect
435     EXIT try
440   END REPeat try
445   DEALLOCATE buffer
450 END REPeat maker
455 IF popup>0
460   MOVE_MEMORY scrsize,popup TO scrposn
465   DEALLOCATE popup
470 END IF
475 STOP
480 :
500 DEFine PROCedure DATASTORE(line%)
510 LOCal i, x, words%, key%, checksum%
520 REMark RESTORE line%
530 key%=3 : READ checksum%, words%
540 FOR i=0 TO words% * 2 -2 STEP 2
550   READ x : POKE_W i+b,x
555   IF x>32767 THEN x=x-65536
560   key%=key% ^^ x ^^ i
570 END FOR i
580 IF key%<>checksum%
590   PRINT "Error in DATA line" ! line% : STOP
600 END IF
610 b=b + words% * 2
620 END DEFine DATASTORE
630 :
635 REMark BASIC Initialisation code
640 DATA 14403,5,17402,8,13432,272,20178
650 REMark Resident procedure code
660 DATA 1777,9,28922,20085,32256,31232,48075,26478,2101,4,59641
670 DATA 9730,9,26384,2245,31,18997,59640,26118,20877,48075,26454
680 DATA 8803,9,18997,59641,27422,10315,18413,65528,13432,278,20114
690 DATA 21657,9,26314,14897,59392,26114,21641,47563,26422,10827,9804
700 DATA -18292,9,13432,280,20114,26290,15875,10313,12337,59394,27558
710 DATA -28691,10,49404,40,53422,48,45230,52,27800,8246,2048,27538
720 DATA -31025,11,9088,59392,22665,21315,26332,8780,9788,0,0,9276,0
730 DATA -28043,9,2,29439,37833,28673,20033,19072,26218,18928,10248
740 DATA -3989,10,18420,14584,59530,8776,17914,94,8922,8922,8922,8922
750 DATA 16476,8,20938,65526,12295,53312,19013,26116,16995,24582
760 DATA -17263,9,22085,57933,53317,38592,38592,47052,25894,10315,8814
770 DATA 26696,9,88,24582,14065,59392,21641,20936,65528,19015,26122
780 DATA 18685,9,32257,9326,48,10550,43048,14599,8524,65524,29712
790 DATA 20555,7,30463,19077,27138,30208,28682,20033,20085
