100 REMark QDOS/ARGOS  Kinetic String animation
110 REMark By Simon N Goodwin, after Louis Cesa
120 REMark Version 1.1, tested 14th November 1991
130 REMark Uses DIY Toolkit CHAN_W%, CHAN_L, PLOT & DRAW
140 REMark Next 4 lines are TURBO optimisation directives
150 REMark IMPLICIT% x1,x2,y1,y2,dx1,dx2,dy1,dy2,stripe,bounce
160 REMark IMPLICIT% place,delta,limit,here,c,tx1,tx2,ty1,ty2
170 REMark IMPLICIT% xmax,ymax,col,size,a
180 REMark IF COMPILED : OPEN #1,"CON_512x256a000x000"
190 INK 7 : PAPER 0
200 WINDOW 512,256,0,0
210 OVER 0 : CSIZE 2,0
220 CLS
230 INPUT "Pattern size ";size :REMark Maximum lines at once
240 DIM c(size),tx1(size),tx2(size),ty1(size),ty2(size)
250 OVER -1 : CLS : RANDOMISE
260 xmax=CHAN_W%(#1,28)-1 : ymax=CHAN_W%(#1,30)-1
270 LET x1=100 : x2=200 : y1=RND(150) : y2=RND(100 TO 125)
280 LET dx1=1 : dx2=-1 : dy1=-1 : dy2=1
290 LET stripe=1 : bounce=1 : col=7
300 REPeat animate
310   FOR a=1 TO size
320     INK c(a)
330     PLOT tx1(a),ty1(a)
340     DRAW tx2(a),ty2(a)
350     bounce=bounce-1 : stripe=stripe-1
360     IF stripe=0
370       stripe=RND(5 TO 50)
380       REPeat pick_colour
390         col=RND(255) : INK col
400         IF CHAN_L(#1,62) : EXIT pick_colour
410       END REPeat pick_colour
420     END IF
430     IF bounce=0
440       bounce=RND(5 TO 100)
450       IF RND(1)
460         dx1=RND(-9 TO 9) : dy1=RND(-4 TO 4)
470       ELSE
480         dx2=RND(-9 TO 9) : dy2=RND(-4 TO 4)
490       END IF
500     END IF
510     ADVANCE x1,dx1,xmax : ADVANCE y1,dy1,ymax
520     ADVANCE x2,dx2,xmax : ADVANCE y2,dy2,ymax
530     INK col : c(a)=col
540     tx1(a)=x1 : ty1(a)=y1 : tx2(a)=x2 : ty2(a)=y2
550     PLOT x1,y1 : DRAW x2,y2
560   END FOR a
570 END REPeat animate
580 :
590 REMark (TURBO only) REFERENCE place,delta
600 DEFine PROCedure ADVANCE(place,delta,limit)
610 LOCal here
620 here=place+delta
630 IF here<0 OR here>limit : here=place : delta=-delta
640 place=here
650 END DEFine ADVANCE
