100 REMark MAPS v 1.3 - for TURBO - uses #15
110 REMark QL World DIY Toolkit, PR Spink & SN Goodwin
120 REMark The next nine lines perform TURBO initialisation
130 :
140 DATA_AREA 1 :REMark 1K DATASPACE should be plenty
150 IF NOT COMPILED : OPEN #15,"SCR_480x210a0x0"
160 DIM t$(8) :REMark space for options
170 IF OPTION_CMD$=""
180   t$="*=CBT   " :REMark Default for patching
190 ELSE
200   t$=OPTION_CMD$
210 END IF
220 :
230 IF t$="?" OR "H" INSTR t$
240   PRINT #15; \"MAP options are:"
250   PRINT #15; \"A for ALL details"
260   PRINT #15;  "B for SuperBASIC"
270   PRINT #15;  "C for COMMON HEAP"
280   PRINT #15;  "R for RESPR space"
290   PRINT #15;  "S for SYSTEM usage"
300   PRINT #15;  "T for TASK memory"
310   PRINT #15; \"? for this message"
320   PRINT #15; \'e.g.  MAP #3,"BT"' : STOP
330 END IF
340 IF "A" INSTR t$ THEN t$="SCBTR":REMark ALL
350 IF "S" INSTR t$
360   PRINT #15;\"System Variables & tables occupy a fixed"!
370   PRINT #15;!PEEK_L(SYSBASE+4)-SYSBASE!"bytes."
380 END IF
390 IF "C" INSTR t$ : COMMON_HEAP
400 IF "B" INSTR t$
410   PRINT #15; \'"';VER$;'" SuperBasic occupies'!
420   PRINT #15;!PEEK_L(SYSBASE+20)-PEEK_L(SYSBASE+16)!"bytes, with"!
430   PRINT #15; !PEEK_L(SYSBASE+16)-PEEK_L(SYSBASE+12)!"more available."
440 END IF
450 IF "T" INSTR t$ : TASK_HEAP
460 IF "R" INSTR t$
470   PRINT #15; \"Resident procedures, functions and"!"devices occupy"!
480   PRINT #15;!PEEK_L(SYSBASE+32)-PEEK_L(SYSBASE+28)!"bytes."
490 END IF
495 CLOSE
500 :
510 DEFine PROCedure COMMON_HEAP
520   PRINT #15; \TO 16;"COMMON HEAP MEMORY"
530   PRINT #15; "Start" TO 10;"Length" TO 20;"Link";
540   PRINT #15; TO 30;"Flag" TO 40; "Owner"
550   HEAP SYSBASE+4 , SYSBASE+12
560 END DEFine COMMON_HEAP
570 :
580 DEFine PROCedure TASK_HEAP
590   PRINT #15; \TO 16;"TRANSIENT PROGRAM MEMORY"
600   PRINT #15; "Start" TO 10;"Length" TO 20;"Job base";
610   PRINT #15; TO 30;"Flag" TO 40; "Owner" TO 54; "Name"
620   HEAP SYSBASE+20 , SYSBASE+28
630 END DEFine TASK_HEAP
640 :
650 DEFine PROCedure HEAP(startp,nextp)
660 LOCal length,address,jobtag,jobnum,addset,start,free_ptr
670 REMark List heap blocks and indicate ownership
680 :
690 start = PEEK_L(startp)         : REMark first block
700 free_ptr = NEXT_FREE(startp)   : REMark first free block
710 :
720 REPeat scan
730   IF start >= PEEK_L(nextp): EXIT scan
740   length = PEEK_L(start)
750   address = PEEK_L(start+4)
760   jobtag = PEEK_W(start+8)
770   jobnum = PEEK_W(start+10)
780   addset = PEEK_L(start+12)
790 :
800   REMark is this block free
810   IF start = free_ptr
820     PRINT #15; start; TO 10; length; TO 20; address;  TO 40; "<< FREE >>"
830     free_ptr = NEXT_FREE(free_ptr) : REMark Find next free block
840   ELSE
850     PRINT #15; start; TO 10; length; TO 20; address; TO 30; addset; TO 40;
860     REMark Name of owner of area
870     PRINT #15; JOB_NAME$(jobnum,jobtag);
880     REMark This should only be true for the transient program area
890     IF PEEK_W(start+110) = 19195
900        REMark Name of job
910        PRINT #15; TO 54;PEEK$(start+114,PEEK_W(start+112));
920     END IF
930     PRINT #15
940   END IF
950   start = start + length : REMark Find start of next block
960 END REPeat scan
970 END DEFine CHEAP
980 :
990 DEFine FuNction NEXT_FREE(start)
1000  REMark Find next free space in common heap
1010  REMark start = address of the start of a free block
1020  IF PEEK_L(start)= 0
1030    REMark End of linked list
1040    RETurn 0
1050  ELSE
1060    REMark return start of next free block
1070    RETurn start+PEEK_L(start+4)
1080  END IF
1090 END DEFine NEXT_FREE
1100 :
1110 DEFine FuNction JOB_NAME$(num,tag)
1120  IF  num = 0
1130    RETurn "SuperBASIC"
1140  ELSE
1150    sv_chbas = PEEK_L(SYSBASE+104)
1160    jb_ptr = sv_chbas+(num*4)
1170    REMark Is this job number in use ?
1180    IF PEEK(jb_ptr) <> 255
1190      jb_start = PEEK_L(jb_ptr)
1200      REMark Is the tag correct ?
1210      IF tag = PEEK_W(jb_start+16)
1220        REMark Is that an Ident Word (19195 = $4AFB) ?
1230        IF PEEK_W(jb_start+110) = 19195
1240          RETurn PEEK$(jb_start+114,PEEK_W(jb_start+112))
1250        ELSE
1260          RETurn "No Name"
1270        END IF
1280      END IF
1290    END IF
1300    RETurn "** Not Valid"
1310  END IF
1320 END DEFine JOB_NAME$
1330 :
1340 DEFine FuNction SYSBASE
1350 REMark Redundant if you have the DIY Toolkit equivalent
1360  IF VER$="JSL1"
1370    RETurn VER$(-2):REMark Locate Minerva system variables
1380  ELSE
1390    RETurn 163840
1400  END IF
1410 END DEFine SYSBASE
1420 :
1430 DEFine FuNction PEEK$(addr,len%)
1440 REMark Redundant if you have the Turbo Toolkit equivalent
1450 LOCal p,t$
1460  t$=''
1470  FOR p=addr TO addr+len%-1
1480    t$=t$ & CHR$(PEEK(p))
1490  END FOR p
1500  RETurn t$
1510 END DEFine PEEK$
