100 REMark MTRAP/QTRAP Demonstrations for THORs, Tested on Argos 6.41
110 REMark Version 0.3, Copyright 1991 Simon N Goodwin
120 REMark READ_WATER calls ALLOC & DEALLOC; DMODE & DEALLOC use SYS_VARS
130 :
140 DEFine FuNction ALLOC(bytes)
150 REMark Allocates BYTES on the Common Heap
160 IF bytes>0
170   MTRAP 24,bytes,-1 :REMark Owner = Caller
180   IF DATAREG=0 : RETurn ADDREG
190 END IF 
200 PRINT #0;"**** Unable to ALLOC ";bytes: STOP
210 END DEFine ALLOC
220 :
230 DEFine PROCedure DEALLOC(base)
240 REMark Deallocate heap at BASE, if valid
250 IF base>163840 AND base-INT(base/8)*8 = 0
260   IF base<PEEK_L(SYS_VARS+12)
270     MTRAP 25,0,0,0,base : RETurn 
280   END IF 
290 END IF 
300 PRINT #0;"**** Unable to DEALLOC ";bytes: STOP
310 END DEFine DEALLOC
320 :
330 DEFine FuNction BACKUP_DATE(file$)
340 OPEN_IN #3,file$
350 QTRAP #3,76,-1,2
360 CLOSE #3
370 REMark Return date from D1 or error code
380 RETurn DATAREG(DATAREG=0)
390 END DEFine BACKUP_DATE
400 :
410 DEFine FuNction REFERENCE_DATE(file$)
420 REMark Not supported by Miracle HD V2
430 OPEN_IN #3,file$
440 QTRAP #3,76,-1,1
450 CLOSE #3
460 RETurn DATAREG(DATAREG=0)
470 END DEFine REFERENCE_DATE
480 :
490 DEFine FuNction UPDATE_DATE(file$)
500 REMark EG: print date$(update_date("ram1_x"))
510 OPEN_IN #3,file$
520 QTRAP #3,76,-1,0
530 CLOSE #3
540 RETurn DATAREG(DATAREG=0)
550 END DEFine UPDATE_DATE
560 :
570 DEFine PROCedure SET_DATE(file$,which%,setting)
580 REMark Tested on THOR XVI version 6.41
590 REMark EG: SET_DATE "ram1_x",2,0 sets BACKUP DATE to NOW
600 REMark     SET_DATE "ram1_x",1,5 sets REFERENCE DATE to 0:0:5 1/1/61
610 REMark     SET_DATE "ram1_x",0,time sets UPDATE DATE to TIME
620 IF which%<0 OR which%>2 : PRINT #0;"**** Cannot SET_DATE ";which% : STOP
630 OPEN #3,file$ : QTRAP #3,76,setting,which% : CLOSE #3
640 END DEFine SET_DATE
650 :
660 DEFine PROCedure READ_WATER(field%)
670 LOCal base,i
680 REMark Reads a field from the Thor Watermark
690 REMark Field 0 = name (4 bytes, normally "THOR")
700 REMark 1 = serial (4 byte Serial No. + 4 byte key)
710 REMark 2 = Default language (1 byte)
720 base=ALLOC(8) :REMark Should be enough!
730 OPEN_OVER #3,"ram1_" :REMark Dummy file
740 QTRAP #3,78,field%,8,-1,base
750 CLOSE #3
760 PRINT "Field"!field%!"has"!DATAREG(1)!"bytes:"!
770 FOR i=base TO base+DATAREG(1)-1:PRINT !PEEK(i)!
780 PRINT
790 DEALLOC base
800 END DEFine READ_WATER
810 :
820 REMark Use these PROCS to set INK, PAPER & STRIP if you
830 REMark want to use MODE 12 in TURBO or Supercharged tasks
840 REMark - See VALHALLA REVISITED, March 1991 QL WORLD
850 REMark QTRAP colour calls expect colour numbers 0-1023
860 :
870 DEFine PROCedure PAPER%(ch%,col%)
880 LOCal pcol%
890 pcol%=PACK%(col%)
900 REMark Set PAPER for CLS etc
910 QTRAP #ch%,39,pcol%
920 REMark Set STRIP for PRINT etc
930 QTRAP #ch%,40,pcol%
940 END DEFine 
950 :
960 DEFine PROCedure STRIP%(ch%,col%)
970 QTRAP #ch%,40,PACK%(col%)
980 END DEFine 
990 :
1000 DEFine PROCedure INK%(ch%,col%)
1010 QTRAP #ch%,41,PACK%(col%)
1020 END DEFine 
1030 :
1040 DEFine FuNction PACK%(c%)
1050 IF c%<0 OR c%>1023
1060   PRINT #0;"Invalid colour:";c% : STOP
1070 ELSE 
1080   RETurn (c% && 255) + 64*(c% && 256)-32768*(c%>511)
1090 END IF 
1100 END DEFine 
1110 :
1120 DEFine FuNction DMODE%
1130 REMark Returns current MODE, 4, 8 or 12
1140 LOCal temp%
1150 temp%=PEEK(SYS_VARS+52) && 12
1160 IF temp% : RETurn temp% : ELSE RETurn 4
1170 END DEFine 
1180 :
1190 DEFine FuNction COLOUR%(float)
1200 LOCal temp%
1210 IF float<0 OR float>255.75
1220   PRINT #0;"Invalid colour:";float
1230   STOP
1240 ELSE 
1250   temp%=float*4
1260   IF temp% && 3 = 3 : RETurn 768+temp% DIV 4
1270   IF temp% && 1 : RETurn 512+temp% DIV 4
1280   IF temp% && 2 : RETurn 256+temp% DIV 4
1290 END IF 
1300 END DEFine 
